## rocblas 6.4.1+dfsg

=== CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2016-2024 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell cop-
# ies of the Software, and to permit persons to whom the Software is furnished
# to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IM-
# PLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNE-
# CTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
# ########################################################################

cmake_minimum_required( VERSION 3.16.8 )


# This has to be initialized before the project() command appears
# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT DEFINED CMAKE_CONFIGURATION_TYPES AND NOT DEFINED CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." )
endif()

# ROCM_BUILD_ID is added to the package name by rocm-cmake ROCMSetupVersion
unset(ENV{ROCM_BUILD_ID})

project( rocblas LANGUAGES CXX )

# Append our library helper cmake path and the cmake path for hip (for convenience)
list( APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake )
include(build-options) # library and client
include(toolchain-options)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

if(NOT python)
  find_package(Python3 REQUIRED COMPONENTS Interpreter)
  set(python "${Python3_EXECUTABLE}")
endif()

# ########################################################################
# Main
# ########################################################################

# This finds the rocm-cmake project, and installs it if not found
# rocm-cmake contains common cmake code for rocm projects to help setup and install
set( PROJECT_EXTERN_DIR ${CMAKE_CURRENT_BINARY_DIR}/extern )
find_package( ROCM 0.7.3 CONFIG QUIET PATHS ${ROCM_PATH} /opt/rocm )
if( NOT ROCM_FOUND )
  set( rocm_cmake_tag "master" CACHE STRING "rocm-cmake tag to download" )
  file( DOWNLOAD https://github.com/RadeonOpenCompute/rocm-cmake/archive/${rocm_cmake_tag}.zip
      ${PROJECT_EXTERN_DIR}/rocm-cmake-${rocm_cmake_tag}.zip STATUS status LOG log)

  list(GET status 0 status_code)
  list(GET status 1 status_string)

  if(NOT status_code EQUAL 0)
    message(FATAL_ERROR "error: downloading
    'https://github.com/RadeonOpenCompute/rocm-cmake/archive/${rocm_cmake_tag}.zip' failed
    status_code: ${status_code}
    status_string: ${status_string}
    log: ${log}
    ")
  endif()

  message(STATUS "downloading... done")

  execute_process( COMMAND ${CMAKE_COMMAND} -E tar xzvf ${PROJECT_EXTERN_DIR}/rocm-cmake-${rocm_cmake_tag}.zip
    WORKING_DIRECTORY ${PROJECT_EXTERN_DIR} )
  execute_process( COMMAND ${CMAKE_COMMAND} -DCMAKE_INSTALL_PREFIX=${PROJECT_EXTERN_DIR}/rocm-cmake .
    WORKING_DIRECTORY ${PROJECT_EXTERN_DIR}/rocm-cmake-${rocm_cmake_tag} )
  execute_process( COMMAND ${CMAKE_COMMAND} --build rocm-cmake-${rocm_cmake_tag} --target install
    WORKING_DIRECTORY ${PROJECT_EXTERN_DIR})

  find_package( ROCM 0.7.3 REQUIRED CONFIG PATHS ${PROJECT_EXTERN_DIR}/rocm-cmake )
endif( )

# rocm-cmake helpers
include( ROCMSetupVersion )
include( ROCMCreatePackage )
include( ROCMInstallTargets )
include( ROCMPackageConfigHelpers )
include( ROCMInstallSymlinks )
include( ROCMCheckTargetIds )
include( ROCMHeaderWrapper )
include( ROCMClients )


include (os-detection)
get_os_id(OS_ID)
message (STATUS "OS detected is ${OS_ID}")

# Versioning via rocm-cmake
set ( VERSION_STRING "4.4.0" )
rocm_setup_version( VERSION ${VERSION_STRING} )

# Users may override HIP path by specifying their own in CMAKE_MODULE_PATH
# NOTE:  workaround until llvm & hip cmake modules fixes symlink logic in their config files; remove when fixed
list( APPEND CMAKE_PREFIX_PATH ${ROCM_PATH}/llvm ${ROCM_PATH} ${ROCM_PATH}/hip /opt/rocm/llvm /opt/rocm /opt/rocm/hip )

# setting target list based on ROCm version
if (NOT BUILD_ADDRESS_SANITIZER)
  set( TARGET_LIST_ROCM_5.6 "gfx803;gfx900;gfx906:xnack-;gfx908:xnack-;gfx90a:xnack+;gfx90a:xnack-;gfx1010;gfx1012;gfx1030;gfx1100;gfx1101;gfx1102")
  set( TARGET_LIST_ROCM_5.7 "gfx803;gfx900;gfx906:xnack-;gfx908:xnack-;gfx90a:xnack+;gfx90a:xnack-;gfx940;gfx941;gfx942;gfx1010;gfx1012;gfx1030;gfx1100;gfx1101;gfx1102")
  set( TARGET_LIST_ROCM_6.0 "gfx900;gfx906:xnack-;gfx908:xnack-;gfx90a:xnack+;gfx90a:xnack-;gfx940;gfx941;gfx942;gfx1010;gfx1012;gfx1030;gfx1100;gfx1101;gfx1102")
  set( TARGET_LIST_ROCM_6.3 "gfx900;gfx906:xnack-;gfx908:xnack-;gfx90a;gfx942;gfx1010;gfx1012;gfx1030;gfx1100;gfx1101;gfx1102;gfx1151;gfx1200;gfx1201")
else()
  set( TARGET_LIST_ROCM_5.6 "gfx908:xnack+;gfx90a:xnack+")
  set( TARGET_LIST_ROCM_5.7 "gfx908:xnack+;gfx90a:xnack+;gfx942:xnack+")
  set( TARGET_LIST_ROCM_6.0 "gfx908:xnack+;gfx90a:xnack+;gfx942:xnack+")
  set( TARGET_LIST_ROCM_6.3 "gfx908:xnack+;gfx90a:xnack+;gfx942:xnack+")
endif()

if(ROCM_PLATFORM_VERSION)
  if(${ROCM_PLATFORM_VERSION} VERSION_LESS 5.7.0)
    set(SUPPORTED_TARGETS "${TARGET_LIST_ROCM_5.6}")
  elseif(${ROCM_PLATFORM_VERSION} VERSION_LESS 6.0.0)
    set(SUPPORTED_TARGETS "${TARGET_LIST_ROCM_5.7}")
  elseif(${ROCM_PLATFORM_VERSION} VERSION_LESS 6.3.0)
    set(SUPPORTED_TARGETS "${TARGET_LIST_ROCM_6.0}")
  else()
    set(SUPPORTED_TARGETS "${TARGET_LIST_ROCM_6.3}")
  endif()
  message(STATUS "ROCM Platform Version: ${ROCM_PLATFORM_VERSION} default supported gfx list")
else()
  message(STATUS "ROCM Platform Version: ${ROCM_PLATFORM_VERSION} is not set, using latest supported gfx list")
  set(SUPPORTED_TARGETS "${TARGET_LIST_ROCM_6.3}")
endif()

if( AMDGPU_TARGETS AND NOT GPU_TARGETS )
  message( DEPRECATION "AMDGPU_TARGETS use is deprecated. Use GPU_TARGETS." )
  set( GFX_LIST ${AMDGPU_TARGETS} )
elseif( GPU_TARGETS )
  set( GFX_LIST ${GPU_TARGETS} )
else ()
  set( GFX_LIST "all" ) # default if not set
endif()

# gpu arch configuration. GFX_LIST is ignored if already set by -DGPU_TARGETS
set( GPU_TARGETS ${GFX_LIST} CACHE STRING "List of GPUs (gfx targets) to support")
set_property(CACHE GPU_TARGETS PROPERTY STRINGS
  all
  ${SUPPORTED_TARGETS})

# Detect if target ID syntax if supported for default all GPU_TARGETS list
# Sets the GPU_TARGETS with backward compatibility
if (GPU_TARGETS STREQUAL "all")
  rocm_check_target_ids(target_list TARGETS "${SUPPORTED_TARGETS}")
else()
  rocm_check_target_ids(target_list TARGETS "${GPU_TARGETS}")
endif()

# if 'target_list' is empty, then compile does not support the gpu arch passed as an argument.
if(target_list STREQUAL "")
  message(FATAL_ERROR "Unsupported target ${GPU_TARGETS} by compiler, List of supported targets: ${SUPPORTED_TARGETS}")
endif()

# set GPU_TARGETS and AMDGPU_TARGETS before any find_package( hip ...), via tensile or in this file
# to set --offload-arch flags via hip-config.cmake hip::device dependency
set( GPU_TARGETS "${target_list}" CACHE STRING "List of GPUs (gfx targets) to support" FORCE )
set( AMDGPU_TARGETS "${GPU_TARGETS}" CACHE STRING "List of GPUs (gfx targets) to support" FORCE ) # for old hip cmake files backward compatibility

option( BUILD_WITH_HIPBLASLT "Build with HipBLASLt" ON )
set( hipblaslt_path "/opt/rocm" CACHE PATH "Use local HipBLASLt directory" )
set( HIPBLASLT_VERSION 0.10 CACHE STRING "The version of HipBLASLt to be used" )

if( WIN32 OR NOT BUILD_WITH_TENSILE OR NOT BUILD_SHARED_LIBS )
  set( BUILD_WITH_HIPBLASLT OFF )
endif()

function(list_replace list old new)
  foreach( i ${${list}} )
    if( i STREQUAL ${old} )
      list( APPEND new_list ${new} )
    else( )
      list( APPEND new_list ${i} )
    endif( )
    set( ${list} ${new_list} PARENT_SCOPE )
  endforeach( )
endfunction( )

if(NOT SKIP_LIBRARY)
  if( BUILD_WITH_TENSILE )
    # we will have expanded "all" for tensile to ensure consistency as we have local rules
    set( Tensile_ARCHITECTURE "${GPU_TARGETS}" CACHE STRING "Tensile to use which architecture?" FORCE)

    list_replace( Tensile_ARCHITECTURE "gfx90a" "gfx90a:xnack+\;gfx90a:xnack-")

    set( TENSILE_VERSION 4.43.0 CACHE STRING "The version of Tensile to be used")

    if(BUILD_WITH_PIP)
      if (WIN32)
        set( Tensile_ROOT "${CMAKE_BINARY_DIR}/virtualenv/Lib/site-packages/Tensile" )
      endif()

      set( Tensile_TEST_LOCAL_PATH "" CACHE PATH "Use local Tensile directory instead of fetching a GitHub branch" )

      include(virtualenv)

      if (Tensile_TEST_LOCAL_PATH)
        virtualenv_install(${Tensile_TEST_LOCAL_PATH})
        message (STATUS "using local Tensile from ${Tensile_TEST_LOCAL_PATH}, copied to ${Tensile_ROOT}")
      else()
        # Use the virtual-env setup and download package from specified repo:
        set( tensile_fork "ROCmSoftwarePlatform" CACHE STRING "Tensile fork to use" )
        file (STRINGS "tensile_tag.txt" read_tensile_tag)
        set( tensile_tag ${read_tensile_tag} CACHE STRING "Tensile tag to download" )
        virtualenv_install("git+https://github.com/${tensile_fork}/Tensile.git@${tensile_tag}")
        message (STATUS "using GIT Tensile fork=${tensile_fork} from branch=${tensile_tag}")
      endif()
      message(STATUS "Adding ${VIRTUALENV_HOME_DIR} to CMAKE_PREFIX_PATH")
      list(APPEND CMAKE_PREFIX_PATH ${VIRTUALENV_HOME_DIR})
    endif()
    find_package(Tensile ${TENSILE_VERSION} EXACT REQUIRED HIP LLVM)
  endif()
endif()

message(STATUS "Using GPU_TARGETS: ${GPU_TARGETS}")

# Find HIP dependencies
if( CMAKE_CXX_COMPILER_ID MATCHES "Clang" )
  find_package( hip REQUIRED CONFIG PATHS ${HIP_DIR} ${ROCM_PATH} /opt/rocm )
endif( )


# setup rocblas defines used for both the library and clients
if( BUILD_WITH_TENSILE )
    list(APPEND TENSILE_DEFINES BUILD_WITH_TENSILE)
    if( Tensile_SEPARATE_ARCHITECTURES )
        list(APPEND TENSILE_DEFINES ROCBLAS_TENSILE_SEPARATE_ARCH=1)
    else()
        list(APPEND TENSILE_DEFINES ROCBLAS_TENSILE_SEPARATE_ARCH=0)
    endif()
    if( Tensile_LAZY_LIBRARY_LOADING )
        list(APPEND TENSILE_DEFINES ROCBLAS_TENSILE_LAZY_LOAD=1)
  else()
        list(APPEND TENSILE_DEFINES ROCBLAS_TENSILE_LAZY_LOAD=0)
  endif()
endif()

if( BUILD_WITH_HIPBLASLT )
  list( APPEND HIPBLASLT_DEFINES BUILD_WITH_HIPBLASLT )
  rocm_package_add_dependencies(DEPENDS "hipblaslt >= ${HIPBLASLT_VERSION}")
endif()

if( BUILD_CLIENTS_SAMPLES OR BUILD_CLIENTS_TESTS OR BUILD_CLIENTS_BENCHMARKS )
  if(NOT CLIENTS_OS)
    rocm_set_os_id(CLIENTS_OS)
    string(TOLOWER "${CLIENTS_OS}" CLIENTS_OS)
    rocm_read_os_release(CLIENTS_OS_VERSION VERSION_ID)
  endif()
  message(STATUS "OS: ${CLIENTS_OS} ${CLIENTS_OS_VERSION}")
  set(OPENMP_RPM "libgomp")
  set(OPENMP_DEB "libomp-dev")
  set(GFORTRAN_RPM "libgfortran4")
  set(GFORTRAN_DEB "libgfortran4")
  if(CLIENTS_OS STREQUAL "centos" OR CLIENTS_OS STREQUAL "rhel")
    if(CLIENTS_OS_VERSION VERSION_GREATER_EQUAL "8")
      set(GFORTRAN_RPM "libgfortran")
    endif()
  elseif(CLIENTS_OS STREQUAL "ubuntu" AND CLIENTS_OS_VERSION VERSION_GREATER_EQUAL "20.04")
    set(GFORTRAN_DEB "libgfortran5")
  elseif(CLIENTS_OS STREQUAL "sles")
    set(OPENMP_RPM "libgomp1")
  elseif(CLIENTS_OS STREQUAL "mariner" OR CLIENTS_OS STREQUAL "azurelinux")
    set(GFORTRAN_RPM "gfortran")
  endif()

  set( BUILD_CLIENTS ON )

=== deps/requirements.txt ===
# rmake
psutil
# rocBLAS clients use
pyyaml
# Tensile related
msgpack
six
wheel
virtualenv
joblib

=== debian/changelog ===
rocblas (6.4.1+dfsg-1~exp1) experimental; urgency=medium

  [ Christian Bayle ]
  * New upstream version 6.1.5+dfsg
    - Bump SOVER librocblas0 -> librocblas4
  * Rebase patches
  * Add clean override to remove some build files
  * Disable pip build, set cmake debug on
  * Add salsa CI
  * Add missing python3-joblib dep
  * Remove patch fixed upstream
  * Set Tensile_ROOT in debian/rules
  * set --ignore-asm-cap-cache to fix an error
  * Prepare rocm_docs based doc
  * Remove doc generated files at clean
  * Remove references to dfsg violating kernels
  * Disable CMAKE debug
  * Add myself in Uploaders and Debian Copyright

  [ Christian Kastner ]
  * New upstream version 6.4.1+dfsg
  * Rebase patches
  * Drop obsolete patches
  * Add Skip-git-requirement.patch
  * Add Use-local-mathjax.patch
  * Add Extend-docs-conf.py-for-offline-build.patch
  * Update install path version for test data
  * Update internal rocblas version for tensile library path
  * Update ISA compatibility hack to support HIP >= 6
  * Use rocm-target-arch to select and document build GPU arch
  * Add librocm-smi-dev, libroctx-dev to Build-Depends
  * Disable hipBLASlt support until it is packaged
  * d/rules: Drop test data build, upstream does it now
  * librocblas4.symbols:
    - librocblas4.symbols: Replace all C++ symbols with regex
    - Drop removed symbols
    - Add newly appeared symbols
  * Set Tensile compiler to hipcc
  * Exclude more references to DFSG-cleaned kernels
  * Build documentation with python3-rocm-docs
  * Add Built-Using field to librocblas-doc
  * Merge d/rules:dh_clean in into d/clean
  * Update d/clean
  * d/patches: Drop patch numbers
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * d/rules: Drop -S, cmake is inferred
  * Switch test runner over to universal location
  * Tweak d/watch
  * Update d/copyright
  * Update d/gbp.conf to reflect Team use

 -- Christian Kastner <ckk@debian.org>  Fri, 04 Jul 2025 16:11:07 +0200

=== debian/control ===
Source: rocblas
Section: devel
Homepage: https://github.com/ROCm/rocBLAS
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocblas.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocblas
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Christian Kastner <ckk@debian.org>,
           Christian Bayle <bayle@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               gfortran,
               python3-venv,
               python3-yaml,
               python3-joblib,
               python3-msgpack,
               pkg-rocm-tools (>= 0.9.0~exp2),
               hipcc (>= 5.6.1~),
               libamd-comgr-dev (>= 6.0~),
               libhsa-runtime-dev (>= 5.7.1~),
               librocm-smi-dev,
               llvm-17,
               rocm-cmake (>= 5.3.0),
               libmsgpack-cxx-dev,
               libblas-dev,
               libroctx-dev,
               libgtest-dev <!nocheck>
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               python3-doxysphinx <!nodoc>,
               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
               python3-sphinx-external-toc <!nodoc>,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>
Rules-Requires-Root: no

Package: librocblas4
Section: libs
Architecture: amd64 arm64 ppc64el
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: ROCm library for basic linear algebra - library
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS library.

Package: librocblas-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocblas4 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev,
Suggests: librocblas-doc
Description: ROCm library for basic linear algebra - headers
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS development headers.

Package: librocblas4-bench
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocblas4 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Build-Profiles: <!nocheck>
Description: ROCm library for basic linear algebra - benchmarks
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS benchmark client used for
 gathering performance data about library functions.

Package: librocblas4-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocblas4 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
         librocblas4-tests-data
Build-Profiles: <!nocheck>
Description: ROCm library for basic linear algebra - tests
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS test binaries used for verifying
 that the library is functioning correctly. These binaries are only used to
 check whether rocBLAS works correctly on a given GPU, so generally speaking,
 users probably don't need this package.

Package: librocblas4-tests-data
Section: libdevel
Architecture: all
Depends: ${misc:Depends},
Build-Profiles: <!nocheck>
Description: ROCm library for basic linear algebra - test data
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the data files required by the AMD ROCm rocBLAS tests.
 The tests are only used to check whether rocBLAS works correctly on a given
 GPU, so generally speaking, users probably don't need this package.

Package: librocblas-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Breaks: librocblas-dev (<< 5.5.1+dfsg-5~)
Replaces: librocblas-dev (<< 5.5.1+dfsg-5~)
Description: ROCm library for basic linear algebra - documentation
 rocBLAS is a library for performing basic linear algebra routines
 on AMD GPUs. It provides implementations of BLAS operations such as
 dot product (DOT), general matrix multiplication (GEMM), triangular
 matrix multiplication (TRMM), and many others. It is built on the
 AMD ROCm platform and optimized for discrete AMD GPUs. The rocBLAS
 library is implemented in the HIP programming language and is
 supplemented by tuned assembly kernels.
 .
 rocBLAS provides a C99 interface and supports operations on matrices
 of half-, single- or double-precision floating point numbers. The
 library provides variants for its routines that efficiently operate
 on batches of matrices and that support a variety of data layouts.
 .
 This package provides the AMD ROCm rocBLAS documentation.

=== debian/rules ===
#!/usr/bin/make -f
export CXX=hipcc
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz
export VERBOSE=1
export TENSILE_ROCM_ASSEMBLER_PATH=/usr/bin/clang++-17
export TENSILE_ROCM_OFFLOAD_BUNDLER_PATH=/usr/bin/clang-offload-bundler-17
export PATH:=$(PATH):/usr/lib/llvm-17/bin
#export AMD_LOG_LEVEL=4
#--merge-architectures --no-lazy-library-loading
DEBUG_FLAGS=-DCMAKE_FIND_DEBUG_MODE=ON
DEBUG_FLAGS=

CXXFLAGS := $(subst -fstack-protector-strong,-Xarch_host -fstack-protector-strong,$(CXXFLAGS))
CXXFLAGS := $(subst -fcf-protection,-Xarch_host -fcf-protection,$(CXXFLAGS))

# TODO: Switch out the internal rocblas version (4.4.0) for librocblas4
# Not as simple as for the test data, as its used by many CMake targets
CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_CLIENTS_BENCHMARKS=ON \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DAMDGPU_TARGETS="$(shell rocm-target-arch --for-build --sep ';')" \
	-DBUILD_WITH_HIPBLASLT=OFF \
	-DROCBLAS_TENSILE_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/rocblas/4.4.0 \
	-DINSTALL_TEST_DATA_DIR=/usr/share/librocblas4-tests/data \
	-DTensile_COMPILER=hipcc \
	-DTensile_TEST_LOCAL_PATH="../tensile" \
	-DTensile_ROOT="$(CURDIR)/tensile/Tensile" \
	-DTensile_LOGIC=asm_full \
	-DTensile_LIBRARY_FORMAT=msgpack \
	-DTensile_LAZY_LIBRARY_LOADING=OFF \
	-DTensile_SEPARATE_ARCHITECTURES=OFF \
	$(DEBUG_FLAGS) \
	-DBUILD_WITH_PIP=false \
	-DOptions=--ignore-asm-cap-cache \
	-DRUN_HEADER_TESTING=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += \
	-DBUILD_CLIENTS_TESTS=ON
endif

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

# strip cannot handle code object files
override_dh_strip-arch:
	dh_strip --exclude=.hsaco --exclude=.co

override_dh_dwz-arch:
	:

# note: openblas crashes in dot for complex values with M=128, N=800000, incx=-3, incy=-3
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then obj-$(DEB_HOST_GNU_TYPE)/clients/staging/rocblas-test \
	    --gtest_filter="*checkin*:-*known_bug*" \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

override_dh_auto_configure-indep:
	:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# Docs will be available when rocm_docs when rocm_docs package will be available
	# See (ITP - #1099584) https://bugs.debian.org/1099584
	export http_proxy=127.0.0.1:9 ; \
	export https_proxy=127.0.0.1:9 ; \
	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
	latest_version= \
	release_candidate= \
	sphinx-build -b html docs html
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

override_dh_gencontrol:
	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch --for-build)"

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/rocm-@ANY_VERSION@%rocblas-$1%,\
      oversionmangle=s/(.*)/$1+dfsg/,\
      dversionmangle=s/\+dfsg//" \
    https://github.com/rocm/rocblas/tags \
    (?:.*?/)?rocm-@ANY_VERSION@\.tar\.gz debian
opts="filenamemangle=s%.*/rocm-@ANY_VERSION@%tensile-$1%,\
      dversionmangle=auto,\
      component=tensile" \
    https://github.com/rocm/tensile/tags \
    (?:.*?/)?rocm-@ANY_VERSION@\.tar\.gz debian

## rocblas 6.4.3%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                python3-yaml,
                python3-joblib,
                python3-msgpack,
-               pkg-rocm-tools (>= 0.9.0~exp2),
+               pkg-rocm-tools (>= 0.9.0~exp3),
                hipcc (>= 5.6.1~),
                libamd-comgr-dev (>= 6.0~),
                libhsa-runtime-dev (>= 5.7.1~),

## rocblas 6.4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # ########################################################################
-# Copyright (C) 2016-2024 Advanced Micro Devices, Inc. All rights reserved.
+# Copyright (C) 2016-2025 Advanced Micro Devices, Inc. All rights reserved.
 #
 # Permission is hereby granted, free of charge, to any person obtaining a copy
 # of this software and associated documentation files (the "Software"), to deal
@@ -100,7 +100,7 @@
 message (STATUS "OS detected is ${OS_ID}")
 
 # Versioning via rocm-cmake
-set ( VERSION_STRING "4.4.0" )
+set ( VERSION_STRING "4.4.1" )
 rocm_setup_version( VERSION ${VERSION_STRING} )
 
 # Users may override HIP path by specifying their own in CMAKE_MODULE_PATH

=== clients/benchmarks/perf_script/CMakeLists.txt ===
# ########################################################################
# Copyright (C) 2016-2022 Advanced Micro Devices, Inc. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell cop-
# ies of the Software, and to permit persons to whom the Software is furnished
# to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IM-
# PLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNE-
# CTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
#
# ########################################################################

set(GRAPHING_SCRIPTS measurePerformance.py
    plotPerformance.py
    blasPerformanceTesting.py
    errorHandler.py
    performanceUtility.py
    README.txt
  )

foreach( SCRIPT ${GRAPHING_SCRIPTS} )
  #Copy a file to another location.
  configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT} ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} @ONLY )
endforeach( )

=== debian/changelog ===
rocblas (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3+dfsg
  * Update d/gbp.conf to follow DEP-14
    https://dep-team.pages.debian.net/deps/dep14/
  * Update for new rocm-target-arch

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 09:03:13 +0200

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 	-DROCM_SYMLINK_LIBS=OFF \
 	-DBUILD_CLIENTS_BENCHMARKS=ON \
 	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
-	-DAMDGPU_TARGETS="$(shell rocm-target-arch --for-build --sep ';')" \
+	-DAMDGPU_TARGETS="$(shell rocm-target-arch --sep ';')" \
 	-DBUILD_WITH_HIPBLASLT=OFF \
 	-DROCBLAS_TENSILE_LIBRARY_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/rocblas/4.4.0 \
 	-DINSTALL_TEST_DATA_DIR=/usr/share/librocblas4-tests/data \
@@ -90,4 +90,4 @@
 	:
 
 override_dh_gencontrol:
-	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch --for-build)"
+	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch)"

=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/librocblas4-tests/run-tests
Features: test-name=librocblas4-tests
Depends: pkg-rocm-tools, librocblas4-tests, libopenblas0-pthread, rocminfo
Restrictions: skippable, allow-stderr
Architecture: amd64
